<template>
    <div class="container-fluid bg-white">
        <div class="row p-4">
            <div class="col-12 text-right">
                <button
                    class="btn btn-success"
                    @click="$modal.show('store-customer', { view: 'create' })"
                >
                    Create New Customer
                </button>

                <button class="btn btn-primary" @click="downloadExcel()">
                    Download Excel
                </button>
            </div>
        </div>

        <div class="bg-white overflow-wrapper">
            <table class="table">
                <thead>
                    <tr>
                        <th>
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="customers = orderTable(customers, 'id')"
                            />
                            # ID
                        </th>
                        <th>
                            <input
                                v-model="pattern"
                                type="text"
                                class="form-control mb-2"
                                placeholder="..."
                                @input="search()"
                            />
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    customers = orderTable(customers, 'name')
                                "
                            />
                            Name
                        </th>
                        <th>
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    customers = orderTable(customers, 'street')
                                "
                            />
                            Street
                        </th>
                        <th>
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    customers = orderTable(customers, 'city')
                                "
                            />
                            City
                        </th>
                        <th>
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    customers = orderTable(
                                        customers,
                                        'post_code'
                                    )
                                "
                            />
                            Post Code
                        </th>
                        <th>
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    customers = orderTable(
                                        customers,
                                        'created_at'
                                    )
                                "
                            />
                            Created At
                        </th>
                        <th>
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    customers = orderTable(
                                        customers,
                                        'updated_at'
                                    )
                                "
                            />
                            Updated At
                        </th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="(item, index) in customers" :key="index">
                        <td>{{ item.id }}</td>
                        <td>
                            <span
                                class="link-button"
                                @click="
                                    $modal.show('store-customer', {
                                        view: 'edit',
                                        customer: item,
                                    })
                                "
                            >
                                {{ item.name }}
                            </span>
                        </td>
                        <td>{{ item.street }}</td>
                        <td>{{ item.city }}</td>
                        <td>{{ item.post_code }}</td>
                        <td>
                            {{ item.created_at | moment("DD.MM.YYYY HH:MM") }}
                        </td>
                        <td>
                            {{ item.updated_at | moment("DD.MM.YYYY HH:MM") }}
                        </td>
                    </tr>
                </tbody>
                <tbody v-if="!customers.length">
                    <tr>
                        <td colspan="999999">
                            <div class="alert alert-secondary" role="alert">
                                Products list is empty !
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>

        <store-customer :customers="customers" />
    </div>
</template>

<script>
import { loadMoreMixin } from "../../mixin/loadMoreMixin";

export default {
    mixins: [loadMoreMixin],

    data() {
        return {
            customers: [],
            pattern: "",
        };
    },

    mounted() {
        axios
            .post("/api/customers/list", {
                take: this.take,
                skip: this.skip,
                orderBy: {
                    name: "id",
                    value: "desc",
                },
            })
            .then((response) => {
                this.customers = response.data;
            });
    },

    methods: {
        search() {
            axios
                .post("/api/customers/list", {
                    pattern: this.pattern,
                    getAll: true,
                    orderBy: {
                        name: "id",
                        value: "desc",
                    },
                })
                .then((response) => {
                    this.customers = response.data;
                });
        },

        downloadExcel() {
            axios({
                url: "/export/customers",
                method: "POST",
                responseType: "blob",
            }).then((response) => {
                const url = window.URL.createObjectURL(
                    new Blob([response.data])
                );

                const link = document.createElement("a");
                link.href = url;
                link.setAttribute("download", "customers.xlsx");
                document.body.appendChild(link);
                link.click();
            });
        },

        loadMore() {
            // Show loading more
            this.isLoading = true;

            // Get total products
            let length = this.customers.length;

            if (this.load && length >= 50) {
                this.timeout = setTimeout(() => {
                    this.skip += 50;

                    axios
                        .post("/api/customers/list", {
                            take: this.take,
                            skip: this.skip,
                            orderBy: {
                                name: "id",

                                value: "desc",
                            },
                        })
                        .then((response) => {
                            // Merge arrays
                            this.customers = this.customers.concat(
                                response.data
                            );
                            // Hide loading more
                            this.isLoading = false;
                            // disable new calls if there arent any new companies
                            length == this.customers.length
                                ? (this.load = false)
                                : (this.load = true);
                        });
                }, 500);
            } else {
                // Hide loading more
                this.isLoading = false;
            }
        },
    },
};
</script>
